@ECHO OFF
REM Martin Karer, 2009-2011
REM http://sezz.at
ECHO BIOS Flash Disk Image Utitlity (BFDIU) v1.4
ECHO Martin Karer, 2009-2011
ECHO.

SET PWD=%~dp0
SET CDI_TempPath=%PWD%TEMP
SET CDI_ImagesPath=%PWD%Images
SET CDI_Readme=_CreateDiskImage.txt
SET CDI_FlashArguments=
SET CDI_ImageSize=0
SET CDI_FloppySize=1474560

REM Set Name
SET CDI_BiosName=
SET /P CDI_BiosName=BIOS Description: 
IF "%CDI_BiosName%"=="" GOTO End
IF EXIST "%CDI_ImagesPath%\%CDI_BiosName%" (
ECHO WARNING: Directory already exists and WILL BE REMOVED:
ECHO "%CDI_ImagesPath%\%CDI_BiosName%"
PAUSE
RD /S /Q "%CDI_ImagesPath%\%CDI_BiosName%"
)

REM Build Root
IF NOT EXIST "%CDI_ImagesPath%" MKDIR "%CDI_ImagesPath%"
IF EXIST "%CDI_TempPath%" RD /S /Q "%CDI_TempPath%"
MKDIR "%CDI_TempPath%"
COPY "%PWD%DOS\*.*" "%CDI_TempPath%" > NUL

REM Find Flash Utility
FOR %%V IN (*.EXE) DO SET CDI_FlashUtility=%%V

ECHO Flash Utility: %CDI_FlashUtility%
MOVE "%PWD%%CDI_FlashUtility%" "%CDI_TempPath%" > NUL

REM Detect Asus Flash (AFUDOS)
CALL :LowerCase CDI_FlashUtility
REM ASUS
IF "%CDI_FlashUtility:~0,3%"=="afu" SET CDI_FlashArguments=/i
IF "%CDI_FlashUtility:~0,3%"=="afu" ECHO ASUS Flash Utility: %CDI_FlashArguments%
REM ASUS B
IF "%CDI_FlashUtility:~0,4%"=="bupd" SET CDI_FlashArguments=/i
IF "%CDI_FlashUtility:~0,4%"=="bupd" ECHO ASUS B-Flash Utility: %CDI_FlashArguments%
REM Phoenix
IF "%CDI_FlashUtility:~0,4%"=="phla" SET CDI_FlashArguments=/x /s 
IF "%CDI_FlashUtility:~0,4%"=="phla" ECHO PHOENIX BIOS Flash Utility: %CDI_FlashArguments%
REM Phoenix PH16
IF "%CDI_FlashUtility:~0,4%"=="ph16" SET CDI_FlashArguments=/x /c /force /s 
IF "%CDI_FlashUtility:~0,4%"=="ph16" ECHO PHOENIX BIOS Flash Utility 16: %CDI_FlashArguments%
REM AWARD
IF "%CDI_FlashUtility:~0,5%"=="awdfl" SET CDI_FlashArguments=
IF "%CDI_FlashUtility:~0,5%"=="awdfl" ECHO AWDFLASH: %CDI_FlashArguments%
IF "%CDI_FlashUtility:~0,4%"=="awfl" SET CDI_FlashArguments=
IF "%CDI_FlashUtility:~0,4%"=="awfl" ECHO AWDFLASH: %CDI_FlashArguments%
REM INTEL
IF "%CDI_FlashUtility:~0,3%"=="ifl" SET CDI_FlashArguments=/rb /pf 
IF "%CDI_FlashUtility:~0,3%"=="ifl" ECHO Intel Flash Utility: %CDI_FlashArguments%

REM Find BIOS ROM
FOR %%V IN (*.*) DO CALL :CheckIfRomFile %%V
GOTO BuildFloppyImage

:LowerCase
REM By Jiri
REM http://www.robvanderwoude.com/battech_convertcase.php
FOR %%i IN ("A=a" "B=b" "C=c" "D=d" "E=e" "F=f" "G=g" "H=h" "I=i" "J=j" "K=k" "L=l" "M=m" "N=n" "O=o" "P=p" "Q=q" "R=r" "S=s" "T=t" "U=u" "V=v" "W=w" "X=x" "Y=y" "Z=z") DO CALL SET "%1=%%%1:%%~i%%"
ENDLOCAL & GOTO :EOF

:CheckIfRomFile
IF "%*"=="%CDI_FlashUtility%" ENDLOCAL & GOTO :EOF
IF "%*"=="%~nx0" ENDLOCAL & GOTO :EOF
IF "%*"=="%CDI_Readme%" ENDLOCAL & GOTO :EOF
ECHO BIOS ROM: %*
MOVE "%PWD%%*" "%CDI_TempPath%" > NUL
ECHO %CDI_FlashUtility% %CDI_FlashArguments%%* > "%CDI_TempPath%\AUTOEXEC.BAT"
ENDLOCAL & GOTO :EOF

:BuildFloppyImage
REM Calculate Image size
CD "%CDI_TempPath%"
FOR %%V IN (*.*) DO CALL :AddFileSize %%V
CD "%PWD%"
SET CDI_RRDSize=6
IF %CDI_ImageSize% gtr %CDI_FloppySize% SET CDI_RRDSize=7
IF "%CDI_RRDSize%"=="6" ECHO Floppy Image Type: 1,44 MB
IF "%CDI_RRDSize%"=="7" ECHO Floppy Image Type: 2,88 MB
REM Create Image
MKDIR "%CDI_ImagesPath%\%CDI_BiosName%"
"%PWD%Tools\BFI\BFI.EXE" -t=%CDI_RRDSize% -f="%CDI_ImagesPath%\%CDI_BiosName%\FLOPPY.IMA" -b="%PWD%Tools\BOOT98SE.BIN" -l=CTKBIOS "%CDI_TempPath%"
GOTO BuildCDImage

:BuildCDImage
CD /D "%CDI_ImagesPath%\%CDI_BiosName%"
"%PWD%Tools\MKISOFS\MKISOFS.EXE" -r -b FLOPPY.IMA -o BIOSCD.ISO .
CD "%PWD%"
GOTO End

:AddFileSize
SET /A CDI_ImageSize=%CDI_ImageSize%+%~z1
ENDLOCAL & GOTO :EOF

:End
PAUSE
